<?php
//==========================================------
// p4DAV.php  Implements a  Perforce WebDAV server
//==========================================------
// Derived from the open source HTTP_WebDAV_Server class (0.99.1)
// ********************************************
// Runs as a helper for Apache HTTP requests of this pattern...
//       http://[thisdomain]/p4/[Perforce path without initial //]
// Requires a directory "davroot" in the Apache document root for temporary files
// Requires the service of the Perforce command-line client P4.
// Triggered by the following directive included in Apache's conf.ini file...
//       AliasMatch ^/p4.*  [somewhere]/p4DAV.php
// Serves a single Perforce repository whose IP address is specified below
// Resides in a directory with companion files...
// 1) p4DAV.php  [this file] (heavily modified from davserver.php)
// 2) DepotServer.php  (heavily modified from FileSystem.php)
// 3) DAVServer.php  (derived with slight mods from Server.php)
// 4) Tools  (a directory, unmodified from open-source distribution) containing
//  4.1) _parse_lockinfo.php
//  4.2) _parse_propfind.php
//  4.3) _parse_proppatch.php
// *************************************************
// You must edit the section below to your specifications
// *************************************************
$prefix = '/p4';  //  Webserver DAV trigger prefix (Apache AliasMatch)
$base = $_SERVER['DOCUMENT_ROOT'].'/davroot/'; // directory for temp files
$depot_host = 'public.perforce.com';                      // Perforce repository
$depot_port = '1666';                                           // Perforce contact port
$depot_agent = '/usr/local/bin/p4';                       // Perforce command-line client
// ************************************************

require_once realpath('.').'/DepotServer.php';
$URI = $_SERVER['REQUEST_URI'];
$path = (strlen($URI)>strlen($prefix))? substr($URI,strlen($prefix)):'/';
$method = strtoupper($_SERVER['REQUEST_METHOD']);

$bug = false;
if ($bug) {
	$fp = fopen('php://input','r');
	$input = fread($fp,2000);  // Capture non-header data
	fclose($fp);
	$LOG = realpath('~Sites/davroot/webdav_log.txt'); 
	$fp = fopen($LOG,'a');
	if ($fp) { fwrite($fp,$input,strlen($input));fclose($fp); }
	ob_start();
}

$depot = new Depot_Filesystem;
$depot->prefix = $prefix;
$depot->base = $base;
$depot->path = $path;
$depot->depot_host = $depot_host;
$depot->depot_port = $depot_port;
$depot->depot_agent = $depot_agent;
$depot->ServeRequest($method);

if ($bug) {
	$s = ob_get_flush();
}

// ***************
//	START BASIC LOG
// ***************
flush();
$msg = "\n\n";
$req_hdrs = apache_request_headers();
unset($req_hdrs['Accept-Language']);  // suppress junk
//	$msg. =join('',headers_list());  // PHP5 only
$lt = localtime(time(),true);
$t = $lt['tm_hour'].':'.$lt['tm_min'].':'.$lt['tm_sec'];

$msg .= ''.date('m/d/Y',time()).'['.$t."] ".$_SERVER['REMOTE_ADDR'].'=>';
$msg .= $method.' '.$path."\n";
$p=array(); foreach ($req_hdrs as $k=>$v) { $p[]=$k.'='.$v; }
$msg .=join('',$p)."\n";
$LOG = realpath('/Users/daniel/Sites/davroot/webdav_log.txt'); 
$fp = fopen($LOG,'a');
$msg .= $s;
if ($fp) { fwrite($fp,$msg,strlen($msg));fclose($fp); }

// ***************
//	END BASIC LOG
// ***************
?>